
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:p="http://primefaces.org/ui">

<style type="text/css">
    .ui-row-editor .ui-row-editor-pencil {
        margin-left:8px;
    }
</style>

<h:head>
    <link type="text/css" rel="stylesheet" href="#{request.contextPath}/themes/cupertino/skin.css"/>
</h:head>


<h:form id="form">
    <p:growl id="msgs" showDetail="true"/>

    <p:dataTable id="users" widgetVar="users" var="user" value="#{dtUserAddRowView.users}" editable="true" style="margin-bottom:20px">
        <f:facet name="header">
            Row Editing with add functionality
        </f:facet>

        <p:ajax event="rowEdit" listener="#{dtUserAddRowView.onRowEdit}" update=":form:msgs" />
        <p:ajax event="rowEditCancel" listener="#{dtUserAddRowView.onRowCancel}" update=":form:msgs" />

        <p:column headerText="Id">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{user.id}" /></f:facet>
                <f:facet name="input"><p:inputText id="modelInput" value="#{user.id}" style="width:100%"/></f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="Login">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{user.login}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{user.login}" style="width:100%" label="Login"/></f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="HashPass">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{user.hashPass}" /></f:facet>
                <f:facet name="input"><p:inputText value="#{user.hashPass}" style="width:100%" label="HashPass"/></f:facet>
            </p:cellEditor>
        </p:column>

        <p:column headerText="Role">
            <p:cellEditor>
                <f:facet name="output"><h:outputText value="#{user.roleType}" /></f:facet>
                <f:facet name="input">
                    <h:selectOneMenu value="#{user.roleType}" style="width:100%">
                        <f:selectItems value="#{dtUserEditView.roleTypes}" var="user" itemLabel="#{roleType}" itemValue="#{roleType}" />
                    </h:selectOneMenu>
                </f:facet>
            </p:cellEditor>
        </p:column>

        <p:column style="width:32px">
            <p:rowEditor />
        </p:column>
    </p:dataTable>

    <div class="ui-g">
        <div class="ui-g-12">
            <p:commandButton value="Add new row" styleClass="ui-priority-primary" process="@this" update=":form:msgs"
                             action="#{dtUserAddRowView.onAddNew()}" oncomplete="PF('users').addRow();"/>
        </div>
    </div>

</h:form>

</html>